// ListWebCamDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinSetWC.h"
#include "ListWebCamDlg.h"
#include "AddWebCam.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ListWebCamDlg dialog


ListWebCamDlg::ListWebCamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ListWebCamDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ListWebCamDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	iIndexDefaut = -1;
}


void ListWebCamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ListWebCamDlg)
	DDX_Control(pDX, IDC_LISTEWEBCAM, m_cListe);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ListWebCamDlg, CDialog)
	//{{AFX_MSG_MAP(ListWebCamDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DEFAUT, OnDefaut)
	ON_BN_CLICKED(IDC_SUPP, OnSupp)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTEWEBCAM, OnDblclkListewebcam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ListWebCamDlg message handlers

void ListWebCamDlg::SaveListe()
{
	CStdioFile  f;
	if( f.Open("ListeWebCam.txt", CFile::modeCreate | CFile::modeWrite))
	{
		for(int i=0;i<m_cListe.GetItemCount();i++)
		{
			CString sTempo;
			char sLigne[1024];
			m_cListe.GetItemText(i,0,sLigne,1024); sTempo += sLigne;
			m_cListe.GetItemText(i,1,sLigne,1024); sTempo = sTempo + sLigne + "#";
			m_cListe.GetItemText(i,2,sLigne,1024); sTempo = sTempo + sLigne + "#";
			m_cListe.GetItemText(i,3,sLigne,1024); sTempo = sTempo + sLigne + "\n";
			f.WriteString(sTempo);
		}
		f.Close();
	}
	else
		AfxMessageBox("Impossible de sauvegarder le fichier des WebCam",MB_OK,0);
}

void ListWebCamDlg::OnAdd() 
{
	CAddWebCam Dlg;
	if( Dlg.DoModal() == IDOK )
	{

		int iIndex = m_cListe.InsertItem(LVIF_TEXT,0," ",0,0,0,0);
		m_cListe.SetItem(iIndex,1,LVIF_TEXT,Dlg.m_vLibelle,0,0,0,0);
		m_cListe.SetItem(iIndex,2,LVIF_TEXT,Dlg.m_vVendor,0,0,0,0);
		m_cListe.SetItem(iIndex,3,LVIF_TEXT,Dlg.m_vProduct,0,0,0,0);
		SaveListe();
	}
}

void ListWebCamDlg::OnDefaut() 
{
	if(m_cListe.GetSelectedCount() != 0 )
	{
		for(int i=0;i<m_cListe.GetItemCount();i++)
		{
			if(m_cListe.GetItemState(i,LVIS_SELECTED)==LVIS_SELECTED)
			{
				if( iIndexDefaut != -1)
					m_cListe.SetItem(iIndexDefaut,0,LVIF_TEXT," ",0,0,0,0);
				m_cListe.SetItem(i,0,LVIF_TEXT,"*",0,0,0,0);
				iIndexDefaut = i;
				break;
			}
		}
		SaveListe();
	}
}

void ListWebCamDlg::OnSupp() 
{
	if(m_cListe.GetSelectedCount() != 0 )
	{
		if( MessageBox("Voulez-vous supprimer cette WebCam ?","AstroNotes - Question", MB_YESNO | MB_ICONQUESTION ) == IDNO )
			return;
		for(int i=0;i<m_cListe.GetItemCount();i++)
		{
			if(m_cListe.GetItemState(i,LVIS_SELECTED)==LVIS_SELECTED)
			{
				m_cListe.DeleteItem(i);
				break;
			}
		}
		SaveListe();
	}
}

BOOL ListWebCamDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ListView_SetExtendedListViewStyle(m_cListe.m_hWnd,LVS_EX_FULLROWSELECT);

	m_cListe.InsertColumn(0," ",LVCFMT_LEFT, 15, 1);
	m_cListe.InsertColumn(1,"Libell",LVCFMT_LEFT, 320, 1);
	m_cListe.InsertColumn(2,"IDVendor",LVCFMT_LEFT, 70, 1);
	m_cListe.InsertColumn(3,"IDProduct",LVCFMT_LEFT, 70, 2);

	CStdioFile  f;
	if( f.Open("ListeWebCam.txt", CFile::modeRead ) )
	{
		char sLigne[1024];
		while( f.ReadString(sLigne, 1024) > 0 )
		{
			CString sTempo = sLigne;
			CString sDefaut = sTempo.Left(1);
			CString sLibelle = sTempo.Mid(1,sTempo.Find('#')-1);
			CString sVendor = sTempo.Mid(sTempo.Find('#')+1,sTempo.ReverseFind('#')-sTempo.Find('#')-1);
			CString sProduct = sTempo.Mid(sTempo.ReverseFind('#')+1,sTempo.GetLength()-sTempo.ReverseFind('#')-2);
			int iIndex = m_cListe.InsertItem(LVIF_TEXT,0,sDefaut,0,0,0,0);
			m_cListe.SetItem(iIndex,1,LVIF_TEXT,sLibelle,0,0,0,0);
			m_cListe.SetItem(iIndex,2,LVIF_TEXT,sVendor,0,0,0,0);
			m_cListe.SetItem(iIndex,3,LVIF_TEXT,sProduct,0,0,0,0);
		}
		for(int i=0;i<m_cListe.GetItemCount();i++)
		{
			char sLigne[10];
			m_cListe.GetItemText(i,0,sLigne,10);
			if( sLigne[0] == '*' )
				iIndexDefaut = i;
		}
		f.Close();
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void ListWebCamDlg::OnDblclkListewebcam(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnDefaut();
	
	*pResult = 0;
}
