// WinSetWCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinSetWC.h"
#include "WinSetWCDlg.h"
#include "ScanUSBDlg.h"
#include "ListWebCamDlg.h"

#include <wctweak_lib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char *device = "0x0471,0x0311";   // ToUCam Pro 740k
int  useD = 0;

int check_device(WCT_HANDLE *pwct)
{
	unsigned short devVen, devProd;
	char *envDevice;

	if (!*pwct)
	{
		*pwct = wct_create_handle(); 
	}

	if (!useD)
	{	
		CStdioFile  f;
		if( f.Open("ListeWebCam.txt", CFile::modeRead ) )
		{
			char sLigne[1024];
			while( f.ReadString(sLigne, 1024) > 0 )
			{
				CString sTempo = sLigne;
				CString sDefaut = sTempo.Left(1);
				CString sVendor = sTempo.Mid(sTempo.Find('#')+1,sTempo.ReverseFind('#')-sTempo.Find('#')-1);
				CString sProduct = sTempo.Mid(sTempo.ReverseFind('#')+1,sTempo.GetLength()-sTempo.ReverseFind('#')-2);
				if( sDefaut == "*" )
				{
					CString sDevice = sVendor + "," + sProduct;
					sscanf(sDevice, "%x,%x", &devVen, &devProd);
				}
			}
			f.Close();
		}
		else
		{
			if (envDevice = getenv ("WCT_DEVICE") )
				sscanf(envDevice, "%x,%x", &devVen, &devProd);
			else
				sscanf(device, "%x,%x", &devVen, &devProd);
		}
	}
	else
	{
		 sscanf(device, "%x,%x", &devVen, &devProd);
	}
	/* open device */
	if (wct_open(*pwct, devVen, devProd) == -1)
	{
		CString sTemp;
		sTemp.Format("Error while accessing device %d / %d\n", devVen, devProd);
		AfxMessageBox(sTemp, MB_OK);
		return -1;
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSetWCDlg dialog

CWinSetWCDlg::CWinSetWCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinSetWCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinSetWCDlg)
	m_vGain = 0;
	m_vAntiflicker = FALSE;
	m_vBacklight = FALSE;
	m_vBlue = 0;
	m_vDelay = 1;
	m_vNoise = _T("0 - None");
	m_vRed = 0;
	m_vSharpness = 0;
	m_vShutter = 1;
	m_vSpeed = 1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinSetWCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinSetWCDlg)
	DDX_Text(pDX, IDC_GAIN, m_vGain);
	DDV_MinMaxInt(pDX, m_vGain, 0, 65535);
	DDX_Check(pDX, IDC_ANTIFLICKER, m_vAntiflicker);
	DDX_Check(pDX, IDC_BACKLIGHT, m_vBacklight);
	DDX_Text(pDX, IDC_BLUE, m_vBlue);
	DDV_MinMaxInt(pDX, m_vBlue, 0, 65535);
	DDX_Text(pDX, IDC_DELAY, m_vDelay);
	DDV_MinMaxInt(pDX, m_vDelay, 1, 65535);
	DDX_CBString(pDX, IDC_NOISE, m_vNoise);
	DDX_Text(pDX, IDC_RED, m_vRed);
	DDV_MinMaxInt(pDX, m_vRed, 0, 65535);
	DDX_Text(pDX, IDC_SHARPNESS, m_vSharpness);
	DDV_MinMaxInt(pDX, m_vSharpness, 0, 65535);
	DDX_Text(pDX, IDC_SHUTTER, m_vShutter);
	DDV_MinMaxInt(pDX, m_vShutter, 1, 65535);
	DDX_Text(pDX, IDC_SPEED, m_vSpeed);
	DDV_MinMaxInt(pDX, m_vSpeed, 1, 65535);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_AUTO, m_cAuto);
	DDX_Control(pDX, IDC_INDOOR, m_cIndoor);
	DDX_Control(pDX, IDC_OUTDOOR, m_cOutdoor);
	DDX_Control(pDX, IDC_FL, m_cFL);
	DDX_Control(pDX, IDC_MANUEL, m_cManuel);
}

BEGIN_MESSAGE_MAP(CWinSetWCDlg, CDialog)
	//{{AFX_MSG_MAP(CWinSetWCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LISTWEBCAM, OnListwebcam)
	ON_BN_CLICKED(IDC_SCANUSB, OnScanusb)
	ON_BN_CLICKED(IDC_RESTORE, OnRestore)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_FACTORY, OnFactory)
	ON_BN_CLICKED(IDC_GETWEBCAM, OnGetwebcam)
	ON_BN_CLICKED(IDC_SAVEWEBCAM, OnSavewebcam)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINSPEED, OnDeltaposSpinspeed)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINDELAY, OnDeltaposSpindelay)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINBLUE, OnDeltaposSpinblue)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINGAIN, OnDeltaposSpingain)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINRED, OnDeltaposSpinred)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINSHARPNESS, OnDeltaposSpinsharpness)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINSHUTTER, OnDeltaposSpinshutter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSetWCDlg message handlers

BOOL CWinSetWCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_cAuto.SetCheck(1);
	OnGetwebcam();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinSetWCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinSetWCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinSetWCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWinSetWCDlg::OnListwebcam() 
{
	ListWebCamDlg Dlg;
	Dlg.DoModal();
}

void CWinSetWCDlg::OnScanusb() 
{
	ScanUSBDlg dlg;
	char *usb;
	WCT_HANDLE pwct = NULL;

	if (!pwct)
	{
		pwct = wct_create_handle(); 
	}

	usb = wct_scanusb(pwct);
	if (!usb)
		dlg.m_vScan = "Error while scanning the USB bus\n";
	else
	{
		dlg.m_vScan = usb;
		free(usb);  // as said
	}
	wct_close(pwct);
	
	char lf[2];
	lf[0] = 10; lf[1] = '\0'; 
	char crlf[3];
	crlf[0] = 13; crlf[1] = 10;crlf[2] = '\0';
	int i = dlg.m_vScan.Replace(lf,crlf);
	dlg.DoModal();

}

void CWinSetWCDlg::OnRestore() 
{
	WCT_HANDLE	pdev = NULL;
	if( check_device(&pdev) != 0 )
	{
		AfxMessageBox("WinSetWC : Error on open WebCam", MB_OK);
		return;
	}
	if (wct_restore_user((wct_device *)pdev) == -1)
		AfxMessageBox("Error on wct_restore_user",MB_OK);
	else
		AfxMessageBox("wct_restore_user OK",MB_OK);

	wct_close(pdev);
}

void CWinSetWCDlg::OnSave() 
{
	WCT_HANDLE	pdev = NULL;
	if( check_device(&pdev) != 0 )
	{
		AfxMessageBox("WinSetWC : Error on open WebCam", MB_OK);
		return;
	}
	if (wct_save_user((wct_device *)pdev) == -1)
		AfxMessageBox("Error on wct_save_user",MB_OK);
	else
		AfxMessageBox("wct_save_user OK",MB_OK);

	wct_close(pdev);
}

void CWinSetWCDlg::OnFactory() 
{
	WCT_HANDLE	pdev = NULL;
	if( check_device(&pdev) != 0 )
	{
		AfxMessageBox("WinSetWC : Error on open WebCam", MB_OK);
		return;
	}
	if (wct_restore_factory((wct_device *)pdev) == -1)
		AfxMessageBox("Error on wct_restore_factory",MB_OK);
	else
		AfxMessageBox("wct_restore_factory OK",MB_OK);

	wct_close(pdev);
}

void CWinSetWCDlg::OnGetwebcam() 
{
	UpdateData(TRUE);

	WCT_HANDLE	pdev = NULL;
	if( check_device(&pdev) != 0 )
	{
		AfxMessageBox("WinSetWC : Error on open WebCam", MB_OK);
		return;
	}

	int dummy, para1, para2;
	if ( (wct_get_agc((wct_device *)pdev, &dummy) ) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_get_agc", MB_OK); }
	else 
	{
		if( dummy < 0 ) dummy = 0;
		m_vGain = dummy;
	}

	if ( (dummy=wct_get_awb((wct_device *)pdev) ) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_get_awb", MB_OK); }
	m_cAuto.SetCheck(0);
	m_cIndoor.SetCheck(0);
	m_cOutdoor.SetCheck(0);
	m_cFL.SetCheck(0);
	m_cManuel.SetCheck(0);
	if (dummy == WCT_WB_AUTO) 
		m_cAuto.SetCheck(1);
	else if (dummy == WCT_WB_INDOOR)
		m_cIndoor.SetCheck(1);
	else if (dummy == WCT_WB_OUTDOOR)
		m_cOutdoor.SetCheck(1);
	else if (dummy == WCT_WB_FL)
		m_cFL.SetCheck(1);
	else if (dummy == WCT_WB_MANUAL)
	{
		m_cManuel.SetCheck(1);
		para1 = wct_get_red_gain((wct_device *)pdev); para2 = wct_get_blue_gain((wct_device *)pdev);
		m_vRed = para1; m_vBlue = para2;
	}
	else
	{	AfxMessageBox("WinSetWc : Error wct_get_awb", MB_OK); }

/*	if (wct_get_leds((wct_device *)pdev, &para1, &para2) != -1)
	{
		if( para1 > 0 ) m_vLed = 1; else m_vLed = 0;
	}
	else
	{	AfxMessageBox("WinSetWc : Error wct_get_leds", MB_OK); }
*/
	if (wct_get_contour((wct_device *)pdev, &dummy) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_get_contour", MB_OK); }
	else m_vSharpness = dummy;


	if ( (dummy = wct_get_backlight((wct_device *)pdev)) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_get_backlight", MB_OK); }
	else
		if (dummy == WCT_OFF) m_vBacklight = 0; else m_vBacklight = 1;


	if ( (dummy = wct_get_flicker((wct_device *)pdev)) != -1)
	{
		if (dummy == WCT_OFF) m_vAntiflicker = 0; else m_vAntiflicker = 1;
	}
	else
	{	AfxMessageBox("WinSetWc : Error wct_get_flicker", MB_OK); }

	if ( (dummy = wct_get_dynamic_noise((wct_device *)pdev)) != -1)
	{
//		CString sTempo; sTempo.Format("Noise reduction mode: %d ", dummy);
//		AfxMessageBox(sTempo,MB_OK);
//		if (dummy == WCT_DYNN_OFF) printf("(off)");
//		else if (dummy == WCT_DYYN_FULL) printf("(full)");
	}
	else
	{	AfxMessageBox("WinSetWc : Error wct_get_dynamic_noise", MB_OK); }

	wct_close(pdev);

	UpdateData(FALSE);
}

void CWinSetWCDlg::OnSavewebcam() 
{
	if( UpdateData(TRUE) == 0 ) return;

	WCT_HANDLE	pdev = NULL;
	if( check_device(&pdev) != 0 )
	{
		AfxMessageBox("WinSetWC : Error on open WebCam", MB_OK);
		return;
	}

	if (wct_set_agc((wct_device *)pdev, WCT_FIXED, m_vGain) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_agc", MB_OK); }

	if (wct_set_shutter_speed((wct_device *)pdev, WCT_FIXED, m_vShutter) == -1)
	{	AfxMessageBox("WinSetWc : Error set_shutter_speed", MB_OK); }
	
	enum wct_wb_mode wbmode;
	if (m_cAuto.GetCheck() == 1)
		wbmode = WCT_WB_AUTO;
	else if (m_cManuel.GetCheck() == 1)
		wbmode = WCT_WB_MANUAL;
	else if (m_cIndoor.GetCheck() == 1)
		wbmode = WCT_WB_INDOOR;
	else if (m_cOutdoor.GetCheck() == 1)
		wbmode = WCT_WB_OUTDOOR;
	else if (m_cFL.GetCheck() == 1)
		wbmode = WCT_WB_FL;
	else
	{	AfxMessageBox("WinSetWc : Error wct_set_awb", MB_OK); }

	if (wct_set_awb((wct_device *)pdev, wbmode) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_awb", MB_OK); }

	if (wct_set_red_gain((wct_device *)pdev, m_vRed) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_red_gain", MB_OK); }

	if (wct_set_blue_gain((wct_device *)pdev, m_vBlue) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_blue_gain", MB_OK); }

	if (wct_set_wb_speed((wct_device *)pdev, m_vSpeed) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_wb_speed", MB_OK); }

	if (wct_set_wb_delay((wct_device *)pdev, m_vDelay) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_wb_delay", MB_OK); }

	if (wct_set_contour((wct_device *)pdev, m_vSharpness) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_contour", MB_OK); }

	if (wct_set_backlight((wct_device *)pdev, m_vBacklight ? WCT_ON : WCT_OFF) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_backlight", MB_OK); }

	if (wct_set_flicker((wct_device *)pdev, m_vAntiflicker ? WCT_ON : WCT_OFF) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_flicker", MB_OK); }

	enum wct_dynnoise_mode dn;
	if( m_vNoise == "" ) dn = WCT_DYNN_OFF;
	if( m_vNoise[0] == '0' ) dn = WCT_DYNN_OFF;
	if( m_vNoise[0] == '1' ) dn = WCT_DYYN_LOW;
	if( m_vNoise[0] == '2' ) dn = WCT_DYYN_MID;
	if( m_vNoise[0] == '3' ) dn = WCT_DYYN_FULL;
	if (wct_set_dynamic_noise((wct_device *)pdev, dn) == -1)
	{	AfxMessageBox("WinSetWc : Error wct_set_dynamic_noise", MB_OK); }

	wct_close(pdev);
}

void CWinSetWCDlg::OnDeltaposSpinspeed(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);
	int iTempo = m_vSpeed;
	iTempo -= pNMUpDown->iDelta;
	if( iTempo >= 1 && iTempo <= 65535 )
		m_vSpeed = iTempo;
	UpdateData(FALSE);
	*pResult = 0;
}

void CWinSetWCDlg::OnDeltaposSpindelay(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);
	int iTempo = m_vDelay;
	iTempo -= pNMUpDown->iDelta;
	if( iTempo >= 1 && iTempo <= 65535 )
		m_vDelay = iTempo;
	UpdateData(FALSE);
	*pResult = 0;
}

void CWinSetWCDlg::OnDeltaposSpinblue(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);
	int iTempo = m_vBlue;
	iTempo -= pNMUpDown->iDelta;
	if( iTempo >= 0 && iTempo <= 65535 )
		m_vBlue = iTempo;
	UpdateData(FALSE);
	*pResult = 0;
}

void CWinSetWCDlg::OnDeltaposSpingain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);
	int iTempo = m_vGain;
	iTempo -= pNMUpDown->iDelta;
	if( iTempo >= 0 && iTempo <= 65535 )
		m_vGain = iTempo;
	UpdateData(FALSE);
	*pResult = 0;
}

void CWinSetWCDlg::OnDeltaposSpinred(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);
	int iTempo = m_vRed;
	iTempo -= pNMUpDown->iDelta;
	if( iTempo >= 0 && iTempo <= 65535 )
		m_vRed = iTempo;
	UpdateData(FALSE);
	*pResult = 0;
}

void CWinSetWCDlg::OnDeltaposSpinsharpness(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);
	int iTempo = m_vSharpness;
	iTempo -= pNMUpDown->iDelta;
	if( iTempo >= 0 && iTempo <= 65535 )
		m_vSharpness = iTempo;
	UpdateData(FALSE);
	*pResult = 0;
}

void CWinSetWCDlg::OnDeltaposSpinshutter(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);
	int iTempo = m_vShutter;
	iTempo -= pNMUpDown->iDelta;
	if( iTempo >= 1 && iTempo <= 65535 )
		m_vShutter = iTempo;
	UpdateData(FALSE);
	*pResult = 0;
}
