/* (C) 1999-2002 Nemosoft Unv. (webcam@smcc.demon.nl)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/*
 Changes:

  This is now part of the wctweak_lib project to build a static Win32 library

  Additions and changes and mostly deletions for a Win32 Version by BM 20031112
  This is only to support the IOCTLs for the cameras to fiddle  with some features 
  not available in the regular driver all the video stuff has been deleted.

  USB communication takes place through the libusb-win32 drivers

  All restrictions and applications mentioned above still apply to this file
   -- wctweak_lib project (C)2003 M. Burri 

*/

/*
  This file pwc.h remains private to the wctweak_lib build project
*/

#ifndef WCT_H
#define WCT_H


#include "wctweak_lib.h"  // my public

/* Turn some debugging options on/off */
#define WCT_DEBUG 0

#define WCT_INIT_CONST  123898434 // just a number


/* Defines for ToUCam cameras */
#define TOUCAM_HEADER_SIZE		8
#define TOUCAM_TRAILER_SIZE		4


//BM videostuff killed
struct wct_device
{
   int initCheck;
   /* Pointer to our usb_device */
   //struct usb_device *udev;
   struct usb_dev_handle	*udevH;  //BM using libusb-win32
   struct usb_device		*udev;  //BM using libusb-win32

   int type;                    /* type of cam (645, 646, 675, 680, 690) */
   int release;			/* release number */
   int unplugged;		/* set when the plug is pulled */
   int usb_init;		/* set when the cam has been initialized over USB */

   /*** Video data ***/
   int vopen;			/* flag */
//   struct video_device *vdev;
   int vendpoint;		/* video isoc endpoint */
   int vcinterface;		/* video control interface */
   int valternate;		/* alternate interface needed */
};

/* Enumeration of image sizes */
#define PSZ_SQCIF	0x00
#define PSZ_QSIF	0x01
#define PSZ_QCIF	0x02
#define PSZ_SIF		0x03
#define PSZ_CIF		0x04
#define PSZ_VGA		0x05
#define PSZ_MAX		6

#ifdef __cplusplus
extern "C" {
#endif



#ifdef __cplusplus
}
#endif


#endif
